\usepackage{tcolorbox}
\tcbuselibrary{listingsutf8}
\tcbuselibrary{skins}
\tcbuselibrary{xparse}

% Define gobble key for tcblisting.
% Inspired by: https://tex.stackexchange.com/questions/48903/how-to-extend-the-lstinputlisting-command
% TODO: doesn't work correctly if xleftmargin is set afterwards
% TODO: doesn't seem to work correctly if xleftmargin isn't set before
% TODO: revisit calculation of space width
% TODO: it might be easier to simply strip away leading spaces before the code is passed
%       to the listing environment. Use a custom (not tcblisting) environment for that?
\makeatletter
\newlength{\singlespace}
\newlength{\tcblstgobble}
\newlength{\gobbledxleftmargin}
\newlength{\gobbledframexleftmargin}
\newlength{\numbersep}
% The width of a single space.
\settowidth{\singlespace}{\lst@basicstyle \ }
\lst@Key{tcblstgobble}{0}{%
    \setlength{\tcblstgobble}{#1\singlespace} %
    \setlength{\gobbledxleftmargin}{\lst@xleftmargin} % save current xleftmargin
    \addtolength{\gobbledxleftmargin}{-\tcblstgobble} % move left margin left
    \def\lst@xleftmargin{\gobbledxleftmargin} % write back left margin
    \setlength{\gobbledframexleftmargin}{\lst@framexleftmargin} % save current left frameborder
    \addtolength{\gobbledframexleftmargin}{-\tcblstgobble} % move left frameborder left
    \def\lst@framexleftmargin{\gobbledframexleftmargin} % write back lexft frameborder
    \setlength{\numbersep}{3\singlespace} % set basic distance between numbers and left frameborder
    \addtolength{\numbersep}{-\tcblstgobble} % compensate for gobble
    \def\lst@numbersep{\numbersep} % 
}
\makeatother

\NewDocumentCommand{\highlight}{ m }{
  % #1: list of line numbers (used by tikz-foreach)
    \begin{scope}[highlightlines={#1}]
      \foreach \line in \highlightlines {
        \def\yoffset{-\line\baselineskip}
        \coordinate (left) at ([yshift=\yoffset] firstlineleft);
        \coordinate (right) at ([yshift=\yoffset] firstlineright);
        \draw[highlightline]{(left) -- (right)};
      }
    \end{scope}
}

\tikzset{highlightlines/.store in=\highlightlines, highlightlines={}}

% Define custom listing environment for Go.
% #1: additional tcolorbox keys.
% #2: additional listing options.
% #3: tikz options
\NewTCBListing{codeListing}{ !O{} !O{} !O{} }{
  skin=enhanced,
  colback=yellow!5,
  colframe=yellow!50!black,
  listing only,
  fonttitle=\bfseries,
  listing options={language=go, numbers=left, xleftmargin=1em, #2},
  tikz={#3},
  underlay={
    \coordinate (firstlineleft) at ([yshift=-0.5\baselineskip]interior.north west);
    \coordinate (firstlineright) at ([yshift=-0.5\baselineskip]interior.north east);
  },
  underlay={
    \foreach \line in \highlightlines {
      \def\yoffset{-\line\baselineskip}
      \coordinate (left) at ([yshift=\yoffset] firstlineleft);
      \coordinate (right) at ([yshift=\yoffset] firstlineright);
      \draw[highlightline]{(left) -- (right)};
    }
  },
  #1,
}

% Style definitions for highlighting code lines.
\tikzset{highlightline/.style={line width=\baselineskip, color=red!25}}

\NewTotalTCBox{\code}{v}{
    standard jigsaw,
    opacityback=0,
    verbatim, arc=0pt,
    top=0pt,bottom=0pt,left=0mm,right=0mm,
    leftrule=0pt,rightrule=0pt,toprule=0pt,bottomrule=0pt}
    {\lstinline[language=go]{#1}}